# Shunter Migration Guide, 2.0 to 3.0

This guide outlines how to migrate from Shunter 2.x to Shunter 3.x. It outlines breaking changes which might cause issues when you upgrade.

## Route Matching

If you were using regular expressions to match routes against the url in the `routes.json` file, these now need to be delimited with `/` characters.

Before:

```js
{
	"localhost": {
		"^\\/path": {
			"host": "127.0.0.1",
			"port": 1337
		}
	}
}
```

After:

```js
{
	"localhost": {
		"/^\\/path/": {
			"host": "127.0.0.1",
			"port": 1337
		}
	}
}
```
