# Shunter Migration Guide, 3.0 to 4.0

This guide outlines how to migrate from Shunter 3.x to Shunter 4.x. It outlines breaking changes which might cause issues when you upgrade.

## Deprecated content-type removed

Shunter now requires a `Content-Type` of `application/x-shunter+json` in order to transform the response. The previously deprecated `application/x-shunter-json` will now not be transformed, but will instead be ignored like other content-types.

## Deprecated CLI options removed

The following deprecated command line options have now been removed, and replaced with the following alternatives:

* `--sourcedirectory` still available as `--source-directory`
* `--routeoveride` still available as `--route-override`
* `--originoveride` still available as `--origin-override`

## Deploy timestamp moved

The command line option `--deploy-timestamp-header` has now been removed, as we are now by default adding that deploy timestamp to proxied requests as a HTTP header rather than a query string parameter.

## Syslog levels

If you're using the default logger, [Winston](https://github.com/winstonjs/winston/), please note that there are [breaking changes](https://github.com/winstonjs/winston/blob/master/CHANGELOG.md#v200--2015-10-29) in this dependency that may affect your shunter-based application.

## EJS filters

The update from EJS version 0.x to 2.x carries with it the [potential for breaking changes](https://github.com/mde/ejs/blob/master/CHANGELOG.md#v201-2015-01-02); most significantly the removal of the filters feature.
