# Shunter Migration Guide, 4.0 to 5.0

This guide outlines how to migrate from Shunter 4.x to Shunter 5.x. It outlines breaking changes which might cause issues when you upgrade.

## Minimum Node version

Node 8 and older is not supported in Shunter v5, as Node 8 no longer receives "long-term support" from Node.js.

Shunter v5 requires a minimum of Node 12, and at the time of writing is passing tests on Node 12 - 17.

(Node 10 is not supported in Shunter 4 or 5.)

## Logging

### Winston logging filters are deprecated

Dropping support for Node 8 required ugrading [Winston](https://github.com/winstonjs/winston/) from version 2 to 3.

Upgrading Winston means that custom logging filters can no longer be used (if you were using them).

Instead [`filters` should be migrated to `formats`](https://github.com/winstonjs/winston/blob/master/UPGRADE-3.0.md#migrating-filters-and-rewriters-to-formats-in-winston3) and supplied via a [custom logging transport](https://github.com/springernature/shunter/blob/master/docs/configuration-reference.md#log-configuration).
